<?php
/*
 * Shopalot Sample for DoJo Toolkit Tutorial
 * Author: Boris Fritscher
 * Date: Jan. 2007
 *
 * This file is the server backend for retrieving catalog items form the MySql Database
 *
 *
 */
//reduce reporting level
ini_set("error_reporting","E_ALL & ~E_NOTICE");
//start the session, for keeping track of the shopping cart
session_start();
// connect to the mysql database
connect_db("localhost", "shopalot","giveusthemoney", "shopalot");

function my_json_encode($array){
	//test if json_encode exists
	if (function_exists('json_encode')) {
		return json_encode($array);
	}else{
		require('json/JSON.php');
		// create a new instance of Services_JSON
		$json = new Services_JSON();
	    
		// convert a complexe value to JSON notation, and send it to the browser
	    return $json->encode($array);
	}
}

switch($_REQUEST["action"]){

	case 'additem':
		addItem($_REQUEST["itemid"]);
	break;

	case 'search':
		getItems($_REQUEST["keyword"]);
	break;

	case 'reset':
		session_destroy();
		echo "cart has been reseted";
	break;

	default:
	case 'getcart':
		checkoutCart($_SESSION["cart"]);
	break;
}

/*
 * Gets the item from the database, registres it into the cart and sends it back in JSON format
 */
function addItem($id =1){
	//protect input against injection
	$id = mysql_real_escape_string($id);

	$sql = "SELECT * FROM items WHERE id=$id LIMIT 1";
    $result = mysql_query($sql);
    if (!$result){
        die(array("error"=>"Could not successfully run query ($sql) from DB: " . mysql_error()));
    }

    $data = mysql_fetch_assoc($result);
    mysql_free_result($result);

    //add item to cart
    $_SESSION["cart"][]=$data;
	//send item information back
	header('Content-type: text/json');
	echo my_json_encode($data);
}

/**
* Send back a JSON result array found with the keyword
*/
function getItems($keyword = "")
{
	//protect input against injection
	$k = mysql_real_escape_string($keyword);

	$sql = "SELECT * FROM items WHERE name LIKE '%$k%' OR description LIKE '%$k%'";
    $result = mysql_query($sql);

    if (!$result){
        die(array("error"=>"Could not successfully run query ($sql) from DB: " . mysql_error()));
    }

    // While a row of data exists, put that row in $row as an associative array
    while ($row = mysql_fetch_assoc($result)){
        $data[]= $row;
    }
    mysql_free_result($result);

	//send item information back
    header('Content-type: text/json');
    echo my_json_encode($data);
}

//Display content of cart in html format
function checkoutCart($data){
	$total = 0;
	if(!empty($data)){
	$i=0; //used for alteranted row color;
	foreach($data as $value){
		$order[$value['id']]["qty"]++;
		$order[$value['id']]["name"]=$value['name'];
		$order[$value['id']]["price"]=$value['price'];
		$total += $value['price'];
	}?>
	<div class="itemHeader"><div><span>Picture</span> Quantity Item</div> Price</div>
	<?php foreach($order as $id=>$item): ?>
		<div class="itemRow <?php if($i%2){echo "itemAltRow";}?>"><div><img src="items/<?php echo $id;?>.jpg" /><?php echo $item["qty"];?> x <?php echo $item["name"];?></div> <?php echo number_format($item["price"],2);?></div>

	<?php
		$i++;
	endforeach; ?>
	<div class="itemHeader">Total: <?php echo number_format($total,2);?></div>
<?php
	}
}

function connect_db($server, $user, $password, $database){
    $conn = mysql_connect($server, $user, $password);

    if (!$conn) {
        die(array("error"=>"Unable to connect to DB: " . mysql_error()));
    }

    if (!mysql_select_db($database)) {
        die(array("error"=>"Unable to select mydbname: " . mysql_error()));
    }
}
?>